  define MVOR 1
  define MRUECK -1
  define MSTOP 0

  define LON 0
  define LOFF 1

  define M_MANUAL 0

  define SWELLE 128

  define BARDOWNTIME 650
  define DOWNTIME 750
  define WAITTIME 2000

  define t1x 5
  define t1y 33
  define t2x 35
  define t2y 99
  define t3x 95
  define t3y 90
  define t4x 171
  define t4y 80
  define t5x 0
  define t5y 0
  define t6x 0
  define t6y 0
  define barx 37
  define bary 7


  define m1  port[1]
  define m1d port[2]
  define m2  port[3]
  define m2d port[4]
  define m3  port[5]
  define m3d port[6]
  define light port[7]

  define tisch1 port[11]
  define tisch2 port[12]
  define tisch3 port[13]
  define tisch4 port[14]
  define tisch5 port[15]
  define tisch6 port[16]
  define modus port[10]
  define frei port[9]


  define sensor1 ad[1]
  define sensor2 ad[2]
  define schalter1 ad[3]
  define schalter2 ad[4]
  define schalter3 ad[5]

  define s1wert byte
  define s2wert byte
  define swert  byte

  define motor1 byte
  define motor2 byte
  define motor3 byte

  define actx byte
  define acty byte
  define goalx byte
  define goaly byte
  define runs byte
  define sel_tisch byte
  define wait_tisch byte
  define waitvar word
  define send_back_time word
  define serving byte
  define orderx byte
  define ordery byte


  print "1";
  if modus=M_MANUAL then goto manuell
  light=LOFF
  gosub calib
  runs=0
  goalx=barx
  goaly=bary
  gosub move
  gosub motor3_vor
  pause BARDOWNTIME
  gosub motor3_stop
  print "8";
  orderx=0
  ordery=0

#loop
  light=LOFF
  sel_tisch=0
  serving=0
  wait frei=0
  send_back_time=timer
  wait (frei=-1) or (timer-send_back_time>200)
  if (orderx=0) or (frei=-1) then goto get_order
  serving=1
  goalx=orderx
  goaly=ordery
  goto robot_called
#get_order
  light=LON
  goalx=0
  if tisch1=0 then gosub call_t1
  if tisch2=0 then gosub call_t2
  if tisch3=0 then gosub call_t3
  if tisch4=0 then gosub call_t4
  if tisch5=0 then gosub call_t5
  if tisch6=0 then gosub call_t6
  if sel_tisch<>0 then goto robot_called
goto get_order

#robot_called
  light=LOFF
  print "7";
  gosub move
  print "9";
  gosub motor3_vor
  pause DOWNTIME
  gosub motor3_stop
  print "3";
  wait_tisch=0
  waitvar=0
  if serving=0 then gosub bestellung else gosub bring_drink
  print "8";
  goalx=barx
  goaly=bary
  gosub move
  runs=runs+1
  if runs<3 then goto no_calib
  gosub calib
  runs=0
 #no_calib
  gosub motor3_vor
  pause BARDOWNTIME
  gosub motor3_stop
  print "8";
  goto loop

#bestellung
  gosub get_act_tisch
  if wait_tisch<>sel_tisch then goto bestellung
  orderx=goalx
  ordery=goaly
  return

#bring_drink
  gosub get_act_tisch
  waitvar=waitvar+1
  if waitvar=200 then print "4";
  if waitvar=500 then waitvar=0
  if wait_tisch<>sel_tisch then bring_drink
  return

#get_act_tisch
  if tisch1=0 then wait_tisch=1
  if tisch2=0 then wait_tisch=2
  if tisch3=0 then wait_tisch=3
  if tisch4=0 then wait_tisch=4
  if tisch5=0 then wait_tisch=5
  if tisch6=0 then wait_tisch=6
return

#move
  gosub motor3_rueck
  if motor3<>MSTOP then goto move
  gosub motor3_stop
  print "7";
  gosub get_sensor1
  #moveloop1
  gosub check_sensor1
  if actx < goalx then gosub motor1_vor else if actx > goalx then gosub motor1_rueck else gosub motor1_stop
  if actx <> goalx then goto moveloop1

  gosub get_sensor2
  #moveloop2
  gosub check_sensor2
  if acty < goaly then gosub motor2_vor else if acty > goaly then gosub motor2_rueck else gosub motor2_stop
  if acty<>goaly then goto moveloop2
return

#manuell
  if tisch1=0 then gosub motor1_vor else if tisch2<>0 then gosub motor1_stop
  if tisch2=0 then gosub motor1_rueck else if tisch1<>0 then gosub motor1_stop
  if tisch3=0 then gosub motor2_vor else if tisch4<>0 then gosub motor2_stop
  if tisch4=0 then gosub motor2_rueck else if tisch3<>0 then gosub motor2_stop
  if tisch5=0 then gosub motor3_vor else if tisch6<>0 then gosub motor3_stop
  if tisch6=0 then gosub motor3_rueck else if tisch5<>0 then gosub motor3_stop

  gosub check_sensor1
  gosub check_sensor2
  if modus<>M_MANUAL then print "X:",actx,"Y:",acty
goto manuell



#check_sensor1
  swert=sensor1
  if swert<SWELLE and s1wert=1 then actx=actx+motor1
  if swert>SWELLE and s1wert=0 then actx=actx+motor1
  if swert<SWELLE then s1wert=0 else s1wert=1
return

#check_sensor2
  swert=sensor2
  if swert<SWELLE and s2wert=1 then acty=acty+motor2
  if swert>SWELLE and s2wert=0 then acty=acty+motor2
  if swert<SWELLE then s2wert=0 else s2wert=1
return

#get_sensor1
  if sensor1<SWELLE then s1wert=0 else s1wert=1
  return

#get_sensor2
  if sensor2<SWELLE then s2wert=0 else s2wert=1
  return

#call_t1
  goalx=t1x
  goaly=t1y
  sel_tisch=1
return
#call_t2
  goalx=t2x
  goaly=t2y
  sel_tisch=2
return
#call_t3
  goalx=t3x
  goaly=t3y
  sel_tisch=3
return
#call_t4
  goalx=t4x
  goaly=t4y
  sel_tisch=4
return
#call_t5
  goalx=t5x
  goaly=t5y
  sel_tisch=5
return
#call_t6
  goalx=t6x
  goaly=t6y
  sel_tisch=6
return

#motor1_vor
 m1d=0
 m1=1
 motor1=MVOR
 return

#motor1_rueck
if schalter1>SWELLE then goto stop_m1
 m1d=1
 m1=1
 motor1=MRUECK
 return
#stop_m1
 actx=0
#motor1_stop
 m1d=0
 m1=0
 motor1=MSTOP
return

#motor2_vor
 m2d=0
 m2=1
 motor2=MVOR
 return

#motor2_rueck
if schalter2>SWELLE then goto stop_m2
 m2d=1
 m2=1
 motor2=MRUECK
 return
#stop_m2
 acty=0
#motor2_stop
 m2d=0
 m2=0
 motor2=MSTOP
 return

#motor3_vor
 m3d=0
 m3=1
 motor3=MVOR
 return

#motor3_rueck
 if schalter3<SWELLE then goto motor3_stop
 m3d=1
 m3=1
 motor3=MRUECK
 return
#motor3_stop
 m3d=0
 m3=0
 motor3=MSTOP
 return

#calib
 #m_3
  gosub motor3_rueck
  if motor3<>MSTOP then goto m_3
 #m_2
  gosub motor2_rueck
  if motor2<>MSTOP then goto m_2
 #m_1
  gosub motor1_rueck
  if motor1<>MSTOP then goto m_1
  actx=0
  acty=0
  return
end

